Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 3625)
@@ -10,5 +10,5 @@
    !!             -   ! 2008-04  (G. Madec)  sltyle and lim_ctl routine
    !!            3.3  ! 2010-11  (G. Madec) ice-ocean stress always computed at each ocean time-step
-   !!            4.0  ! 2011-01  (A Porter)  dynamical allocation
+   !!            3.4  ! 2011-01  (A Porter)  dynamical allocation
    !!----------------------------------------------------------------------
 #if defined key_lim3
@@ -88,5 +88,5 @@
       !! ** Action  : - time evolution of the LIM sea-ice model
       !!              - update all sbc variables below sea-ice:
-      !!                utau, vtau, taum, wndm, qns , qsr, emp , emps
+      !!                utau, vtau, taum, wndm, qns , qsr, emp , sfx 
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt      ! ocean time step
@@ -170,25 +170,25 @@
 
          !                                           ! intialisation to zero    !!gm is it truly necessary ???
-         d_a_i_thd  (:,:,:)   = 0.e0   ;   d_a_i_trp  (:,:,:)   = 0.e0
-         d_v_i_thd  (:,:,:)   = 0.e0   ;   d_v_i_trp  (:,:,:)   = 0.e0
-         d_e_i_thd  (:,:,:,:) = 0.e0   ;   d_e_i_trp  (:,:,:,:) = 0.e0
-         d_v_s_thd  (:,:,:)   = 0.e0   ;   d_v_s_trp  (:,:,:)   = 0.e0
-         d_e_s_thd  (:,:,:,:) = 0.e0   ;   d_e_s_trp  (:,:,:,:) = 0.e0
-         d_smv_i_thd(:,:,:)   = 0.e0   ;   d_smv_i_trp(:,:,:)   = 0.e0
-         d_oa_i_thd (:,:,:)   = 0.e0   ;   d_oa_i_trp (:,:,:)   = 0.e0
-         !
-         fseqv    (:,:) = 0.e0
-         fsbri    (:,:) = 0.e0     ;   fsalt_res(:,:) = 0.e0
-         fsalt_rpo(:,:) = 0.e0
-         fhmec    (:,:) = 0.e0     ;   fhbri    (:,:) = 0.e0
-         fmmec    (:,:) = 0.e0     ;   fheat_res(:,:) = 0.e0
-         fheat_rpo(:,:) = 0.e0     ;   focea2D  (:,:) = 0.e0
-         fsup2D   (:,:) = 0.e0
+         d_a_i_thd  (:,:,:)   = 0._wp   ;   d_a_i_trp  (:,:,:)   = 0._wp
+         d_v_i_thd  (:,:,:)   = 0._wp   ;   d_v_i_trp  (:,:,:)   = 0._wp
+         d_e_i_thd  (:,:,:,:) = 0._wp   ;   d_e_i_trp  (:,:,:,:) = 0._wp
+         d_v_s_thd  (:,:,:)   = 0._wp   ;   d_v_s_trp  (:,:,:)   = 0._wp
+         d_e_s_thd  (:,:,:,:) = 0._wp   ;   d_e_s_trp  (:,:,:,:) = 0._wp
+         d_smv_i_thd(:,:,:)   = 0._wp   ;   d_smv_i_trp(:,:,:)   = 0._wp
+         d_oa_i_thd (:,:,:)   = 0._wp   ;   d_oa_i_trp (:,:,:)   = 0._wp
+         !
+         sfx    (:,:) = 0._wp
+         sfx_bri(:,:) = 0._wp   ;   sfx_mec  (:,:) = 0._wp   ;   sfx_res  (:,:) = 0._wp
+         fhbri  (:,:) = 0._wp   ;   fheat_mec(:,:) = 0._wp   ;   fheat_res(:,:) = 0._wp
+         fhmec  (:,:) = 0._wp   ;   
+         fmmec  (:,:) = 0._wp     
+         focea2D(:,:) = 0._wp
+         fsup2D (:,:) = 0._wp
          ! 
-         diag_sni_gr(:,:) = 0.e0   ;   diag_lat_gr(:,:) = 0.e0
-         diag_bot_gr(:,:) = 0.e0   ;   diag_dyn_gr(:,:) = 0.e0
-         diag_bot_me(:,:) = 0.e0   ;   diag_sur_me(:,:) = 0.e0
+         diag_sni_gr(:,:) = 0._wp   ;   diag_lat_gr(:,:) = 0._wp
+         diag_bot_gr(:,:) = 0._wp   ;   diag_dyn_gr(:,:) = 0._wp
+         diag_bot_me(:,:) = 0._wp   ;   diag_sur_me(:,:) = 0._wp
          ! dynamical invariants
-         delta_i(:,:) = 0.e0       ;   divu_i(:,:) = 0.e0       ;   shear_i(:,:) = 0.e0
+         delta_i(:,:) = 0._wp       ;   divu_i(:,:) = 0._wp       ;   shear_i(:,:) = 0._wp
 
                           CALL lim_rst_opn( kt )     ! Open Ice restart file
@@ -196,6 +196,5 @@
          IF( ln_nicep )   CALL lim_prt_state( jiindx, jjindx, 1, ' - Beginning the time step - ' )   ! control print
          !
-         IF( .NOT. lk_c1d ) THEN
-                                                     ! Ice dynamics & transport (not in 1D case)
+         IF( .NOT. lk_c1d ) THEN                     ! Ice dynamics & transport (except in 1D case)
                           CALL lim_dyn( kt )              ! Ice dynamics    ( rheology/dynamics )
                           CALL lim_trp( kt )              ! Ice transport   ( Advection/diffusion )
@@ -210,5 +209,5 @@
                           CALL lim_var_bv                 ! bulk brine volume (diag)
                           CALL lim_thd( kt )              ! Ice thermodynamics 
-                          zcoef = rdt_ice / 86400.e0      !  Ice natural aging
+                          zcoef = rdt_ice /rday           !  Ice natural aging
                           oa_i(:,:,:) = oa_i(:,:,:) + a_i(:,:,:) * zcoef
                           CALL lim_var_glo2eqv            ! this CALL is maybe not necessary (Martin)
@@ -268,5 +267,5 @@
 
       inb_altests = 10
-      inb_alp(:)  = 0
+      inb_alp(:)  =  0
 
       ! Alert if incompatible volume and concentration
@@ -277,5 +276,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF(  v_i(ji,jj,jl) /= 0.e0   .AND.   a_i(ji,jj,jl) == 0.e0   ) THEN
+               IF(  v_i(ji,jj,jl) /= 0._wp   .AND.   a_i(ji,jj,jl) == 0._wp   ) THEN
                   WRITE(numout,*) ' ALERTE 2 :   Incompatible volume and concentration '
                   WRITE(numout,*) ' at_i     ', at_i(ji,jj)
@@ -297,5 +296,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF(   ht_i(ji,jj,jl) .GT. 50.0   ) THEN
+            IF(   ht_i(ji,jj,jl)  >  50._wp   ) THEN
                CALL lim_prt_state( ji, jj, 2, ' ALERTE 3 :   Very thick ice ' )
                inb_alp(ialert_id) = inb_alp(ialert_id) + 1
@@ -309,6 +308,6 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF(   MAX( ABS( u_ice(ji,jj) ), ABS( v_ice(ji,jj) ) ) .GT. 0.5  .AND.  &
-               &  at_i(ji,jj) .GT. 0.e0   ) THEN
+            IF(   MAX( ABS( u_ice(ji,jj) ), ABS( v_ice(ji,jj) ) ) > 0.5  .AND.  &
+               &  at_i(ji,jj) > 0._wp   ) THEN
                CALL lim_prt_state( ji, jj, 1, ' ALERTE 4 :   Very fast ice ' )
                WRITE(numout,*) ' ice strength             : ', strength(ji,jj)
@@ -332,5 +331,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF(   tms(ji,jj) .LE. 0.0   .AND.   at_i(ji,jj) .GT. 0.e0   ) THEN 
+            IF(   tms(ji,jj) <= 0._wp   .AND.   at_i(ji,jj) > 0._wp   ) THEN 
                CALL lim_prt_state( ji, jj, 1, ' ALERTE 6 :   Ice on continents ' )
                WRITE(numout,*) ' masks s, u, v        : ', tms(ji,jj), tmu(ji,jj), tmv(ji,jj) 
@@ -356,7 +355,7 @@
             DO ji = 1, jpi
 !!gm  test twice sm_i ...  ????  bug?
-               IF( ( ( ABS( sm_i(ji,jj,jl) ) .LT. 0.50) .OR. &
-                     ( ABS( sm_i(ji,jj,jl) ) .LT. 0.50) ) .AND. &
-                             ( a_i(ji,jj,jl) .GT. 0.e0 ) ) THEN
+               IF( ( ( ABS( sm_i(ji,jj,jl) ) < 0.5 )   .OR.  &
+                     ( ABS( sm_i(ji,jj,jl) ) < 0.5 ) ) .AND. &
+                             ( a_i(ji,jj,jl) > 0._wp ) ) THEN
 !                 CALL lim_prt_state(ji,jj,1, ' ALERTE 7 :   Very fresh ice ' )
 !                 WRITE(numout,*) ' sst                  : ', sst_m(ji,jj)
@@ -377,7 +376,7 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF ( ( ( ABS( o_i(ji,jj,jl) ) .GT. rdt_ice ) .OR. &
-                      ( ABS( o_i(ji,jj,jl) ) .LT. 0.00) ) .AND. &
-                             ( a_i(ji,jj,jl) .GT. 0.0 ) ) THEN
+               IF ( ( ( ABS( o_i(ji,jj,jl) ) > rdt_ice ) .OR. &
+                      ( ABS( o_i(ji,jj,jl) ) < 0._wp) ) .AND. &
+                             ( a_i(ji,jj,jl) > 0._wp ) ) THEN
                   CALL lim_prt_state( ji, jj, 1, ' ALERTE 9 :   Wrong ice age ')
                   inb_alp(ialert_id) = inb_alp(ialert_id) + 1
@@ -392,5 +391,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF( ABS( emps(ji,jj) ) .GT. 1.0e-2 ) THEN
+            IF( ABS( sfx (ji,jj) ) .GT. 1.0e-2 ) THEN
                CALL lim_prt_state( ji, jj, 3, ' ALERTE 5 :   High salt flux ' )
                DO jl = 1, jpl
@@ -412,5 +411,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF(   ABS( qns(ji,jj) ) .GT. 1500.0   .AND.  ( at_i(ji,jj) .GT. 0.0 ) )  THEN
+            IF(   ABS( qns(ji,jj) ) > 1500._wp  .AND.  at_i(ji,jj) > 0._wp  )  THEN
                !
                WRITE(numout,*) ' ALERTE 8 :   Very high non-solar heat flux'
@@ -429,5 +428,5 @@
                WRITE(numout,*) ' fdtcn     : ', fdtcn(ji,jj) 
                WRITE(numout,*) ' fhmec     : ', fhmec(ji,jj) 
-               WRITE(numout,*) ' fheat_rpo : ', fheat_rpo(ji,jj) 
+               WRITE(numout,*) ' fheat_mec : ', fheat_mec(ji,jj) 
                WRITE(numout,*) ' fheat_res : ', fheat_res(ji,jj) 
                WRITE(numout,*) ' fhbri     : ', fhbri(ji,jj) 
@@ -450,6 +449,6 @@
                DO ji = 1, jpi
                   ztmelts    =  -tmut * s_i(ji,jj,jk,jl) + rtt
-                  IF( t_i(ji,jj,jk,jl) .GE. ztmelts  .AND.  v_i(ji,jj,jl) .GT. 1.e-6   &
-                     &                               .AND.  a_i(ji,jj,jl) .GT. 0.e0    ) THEN
+                  IF( t_i(ji,jj,jk,jl) >= ztmelts  .AND.  v_i(ji,jj,jl) > 1.e-6   &
+                     &                             .AND.  a_i(ji,jj,jl) > 0._wp   ) THEN
                      WRITE(numout,*) ' ALERTE 10 :   Very warm ice'
                      WRITE(numout,*) ' ji, jj, jk, jl : ', ji, jj, jk, jl
@@ -606,11 +605,11 @@
         WRITE(numout,*) ' - Heat / FW fluxes '
         WRITE(numout,*) '   ~~~~~~~~~~~~~~~~ '
-!       WRITE(numout,*) ' fsbri      : ', fsbri(ki,kj)
-!       WRITE(numout,*) ' fseqv      : ', fseqv(ki,kj)
+!       WRITE(numout,*) ' sfx_bri    : ', sfx_bri  (ki,kj)
+!       WRITE(numout,*) ' sfx        : ', sfx      (ki,kj)
 !       WRITE(numout,*) ' fsalt_res  : ', fsalt_res(ki,kj)
-        WRITE(numout,*) ' fmmec      : ', fmmec(ki,kj)
-        WRITE(numout,*) ' fhmec      : ', fhmec(ki,kj)
-        WRITE(numout,*) ' fhbri      : ', fhbri(ki,kj)
-        WRITE(numout,*) ' fheat_rpo  : ', fheat_rpo(ki,kj)
+        WRITE(numout,*) ' fmmec      : ', fmmec    (ki,kj)
+        WRITE(numout,*) ' fhmec      : ', fhmec    (ki,kj)
+        WRITE(numout,*) ' fhbri      : ', fhbri    (ki,kj)
+        WRITE(numout,*) ' fheat_mec  : ', fheat_mec(ki,kj)
         WRITE(numout,*) 
         WRITE(numout,*) ' sst        : ', sst_m(ki,kj)  
@@ -621,8 +620,8 @@
         WRITE(numout,*) ' utau_ice   : ', utau_ice(ki,kj) 
         WRITE(numout,*) ' vtau_ice   : ', vtau_ice(ki,kj)
-        WRITE(numout,*) ' utau       : ', utau(ki,kj) 
-        WRITE(numout,*) ' vtau       : ', vtau(ki,kj)
-        WRITE(numout,*) ' oc. vel. u : ', u_oce(ki,kj)
-        WRITE(numout,*) ' oc. vel. v : ', v_oce(ki,kj)
+        WRITE(numout,*) ' utau       : ', utau    (ki,kj) 
+        WRITE(numout,*) ' vtau       : ', vtau    (ki,kj)
+        WRITE(numout,*) ' oc. vel. u : ', u_oce   (ki,kj)
+        WRITE(numout,*) ' oc. vel. v : ', v_oce   (ki,kj)
      ENDIF
 
@@ -640,16 +639,15 @@
         WRITE(numout,*)
         WRITE(numout,*) ' - Heat fluxes at bottom interface ***'
-        WRITE(numout,*) ' qsr        : ', qsr(ki,kj)
-        WRITE(numout,*) ' qns        : ', qns(ki,kj)
+        WRITE(numout,*) ' qsr       : ', qsr(ki,kj)
+        WRITE(numout,*) ' qns       : ', qns(ki,kj)
         WRITE(numout,*)
         WRITE(numout,*) ' - Salt fluxes at bottom interface ***'
-        WRITE(numout,*) ' emps       : ', emps(ki,kj)
-        WRITE(numout,*) ' emp        : ', emp(ki,kj)
-        WRITE(numout,*) ' fsbri      : ', fsbri(ki,kj)
-        WRITE(numout,*) ' fseqv      : ', fseqv(ki,kj)
-        WRITE(numout,*) ' fsalt_res  : ', fsalt_res(ki,kj)
-        WRITE(numout,*) ' fsalt_rpo  : ', fsalt_rpo(ki,kj)
+        WRITE(numout,*) ' emp       : ', emp    (ki,kj)
+        WRITE(numout,*) ' sfx_bri   : ', sfx_bri(ki,kj)
+        WRITE(numout,*) ' sfx       : ', sfx    (ki,kj)
+        WRITE(numout,*) ' sfx_res   : ', sfx_res(ki,kj)
+        WRITE(numout,*) ' sfx_mec   : ', sfx_mec(ki,kj)
         WRITE(numout,*) ' - Heat fluxes at bottom interface ***'
-        WRITE(numout,*) ' fheat_res  : ', fheat_res(ki,kj)
+        WRITE(numout,*) ' fheat_res : ', fheat_res(ki,kj)
         WRITE(numout,*)
         WRITE(numout,*) ' - Momentum fluxes '
Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 3625)
@@ -82,5 +82,5 @@
       !! ** Action  : - time evolution of the LIM sea-ice model
       !!              - update all sbc variables below sea-ice:
-      !!                utau, vtau, taum, wndm, qns , qsr, emp , emps
+      !!                utau, vtau, taum, wndm, qns , qsr, emp , sfx 
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt      ! ocean time step
Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 3625)
@@ -12,4 +12,5 @@
    !!             -   ! 2010-10  (J. Chanut, C. Bricaud, G. Madec)  add the surface pressure forcing
    !!            3.4  ! 2011-11  (C. Harris) CICE added as an option
+   !!            3.5  ! 2012-11  (A. Coward, G. Madec) Rethink of heat, mass and salt surface fluxes
    !!----------------------------------------------------------------------
 
@@ -84,6 +85,7 @@
       INTEGER ::   icpt   ! local integer
       !!
-      NAMELIST/namsbc/ nn_fsbc   , ln_ana , ln_flx  , ln_blk_clio, ln_blk_core, ln_cpl,   &
-         &             ln_blk_mfs, ln_apr_dyn, nn_ice , ln_dm2dc, ln_rnf, ln_ssr     , nn_fwb, ln_cdgw
+      NAMELIST/namsbc/ nn_fsbc   , ln_ana    , ln_flx,  ln_blk_clio, ln_blk_core, ln_cpl,   &
+         &             ln_blk_mfs, ln_apr_dyn, nn_ice,  nn_ice_embd, ln_dm2dc   , ln_rnf,   &
+         &             ln_ssr    , nn_fwb    , ln_cdgw
       !!----------------------------------------------------------------------
 
@@ -121,4 +123,5 @@
          WRITE(numout,*) '              Patm gradient added in ocean & ice Eqs.    ln_apr_dyn  = ', ln_apr_dyn
          WRITE(numout,*) '              ice management in the sbc (=0/1/2/3)       nn_ice      = ', nn_ice 
+         WRITE(numout,*) '              ice-ocean embedded/levitating (=0/1/2)     nn_ice_embd = ', nn_ice_embd
          WRITE(numout,*) '              daily mean to diurnal cycle qsr            ln_dm2dc    = ', ln_dm2dc 
          WRITE(numout,*) '              runoff / runoff mouths                     ln_rnf      = ', ln_rnf
@@ -136,9 +139,12 @@
          IF( sbc_rnf_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_init : unable to allocate sbc_rnf arrays' )
          nkrnf         = 0
-         rnf     (:,:) = 0.e0
-         rnfmsk  (:,:) = 0.e0
-         rnfmsk_z(:)   = 0.e0
+         rnf     (:,:) = 0.0_wp
+         rnfmsk  (:,:) = 0.0_wp
+         rnfmsk_z(:)   = 0.0_wp
       ENDIF
       IF( nn_ice == 0  )   fr_i(:,:) = 0.e0        ! no ice in the domain, ice fraction is always zero
+
+      sfx(:,:) = 0.0_wp                            ! the salt flux due to freezing/melting will be computed (i.e. will be non-zero) 
+                                                   ! only if sea-ice is present
 
       !                                            ! restartability   
@@ -157,6 +163,8 @@
       IF( nn_ice == 4 .AND. .NOT.( ln_blk_core .OR. lk_cpl ) )   &
          &   CALL ctl_stop( 'CICE sea-ice model requires ln_blk_core or lk_cpl' )
-      IF( nn_ice == 4 .AND. ( .NOT. ( cp_cfg == 'orca' ) .OR. lk_agrif ) )   &
-         &   CALL ctl_stop( 'CICE sea-ice model currently only available in a global ORCA configuration without AGRIF' )
+      IF( nn_ice == 4 .AND. lk_agrif )   &
+         &   CALL ctl_stop( 'CICE sea-ice model not currently available with AGRIF' )
+      IF( ( nn_ice == 3 .OR. nn_ice == 4 ) .AND. nn_ice_embd == 0 )   &
+         &   CALL ctl_stop( 'LIM3 and CICE sea-ice models require nn_ice_embd = 2 or 3' )
       
       IF( ln_dm2dc )   nday_qsr = -1   ! initialisation flag
@@ -226,6 +234,6 @@
       !! ** Action  : - set the ocean surface boundary condition at before and now 
       !!                time step, i.e.  
-      !!                utau_b, vtau_b, qns_b, qsr_b, emp_n, emps_b, qrp_b, erp_b
-      !!                utau  , vtau  , qns  , qsr  , emp  , emps  , qrp  , erp
+      !!                utau_b, vtau_b, qns_b, qsr_b, emp_n, sfx_b, qrp_b, erp_b
+      !!                utau  , vtau  , qns  , qsr  , emp  , sfx  , qrp  , erp
       !!              - updte the ice fraction : fr_i
       !!----------------------------------------------------------------------
@@ -243,6 +251,6 @@
          ! The 3D heat content due to qsr forcing is treated in traqsr
          ! qsr_b (:,:) = qsr (:,:)
-         emp_b (:,:) = emp (:,:)
-         emps_b(:,:) = emps(:,:)
+         emp_b(:,:) = emp(:,:)
+         sfx_b(:,:) = sfx(:,:)
       ENDIF
       !                                            ! ---------------------------------------- !
@@ -262,5 +270,5 @@
                                                             
       SELECT CASE( nsbc )                                ! Compute ocean surface boundary condition
-      !                                                  ! (i.e. utau,vtau, qns, qsr, emp, emps)
+      !                                                  ! (i.e. utau,vtau, qns, qsr, emp, sfx)
       CASE(  0 )   ;   CALL sbc_gyre    ( kt )                    ! analytical formulation : GYRE configuration
       CASE(  1 )   ;   CALL sbc_ana     ( kt )                    ! analytical formulation : uniform sbc
@@ -314,7 +322,12 @@
             CALL iom_get( numror, jpdom_autoglo, 'qns_b' , qns_b  )   ! before non solar heat flux (T-point)
             ! The 3D heat content due to qsr forcing is treated in traqsr
-            ! CALL iom_get( numror, jpdom_autoglo, 'qsr_b' , qsr_b  )   ! before     solar heat flux (T-point)
-            CALL iom_get( numror, jpdom_autoglo, 'emp_b' , emp_b  )   ! before     freshwater flux (T-point)
-            CALL iom_get( numror, jpdom_autoglo, 'emps_b', emps_b )   ! before C/D freshwater flux (T-point)
+            ! CALL iom_get( numror, jpdom_autoglo, 'qsr_b' , qsr_b  ) ! before     solar heat flux (T-point)
+            CALL iom_get( numror, jpdom_autoglo, 'emp_b', emp_b  )    ! before     freshwater flux (T-point)
+            ! To ensure restart capability with 3.3x/3.4 restart files    !! to be removed in v3.6
+            IF( iom_varid( numror, 'sfx_b', ldstop = .FALSE. ) > 0 ) THEN
+               CALL iom_get( numror, jpdom_autoglo, 'sfx_b', sfx_b )  ! before salt flux (T-point)
+            ELSE
+               sfx_b (:,:) = sfx(:,:)
+            ENDIF
          ELSE                                                   !* no restart: set from nit000 values
             IF(lwp) WRITE(numout,*) '          nit000-1 surface forcing fields set to nit000'
@@ -322,7 +335,6 @@
             vtau_b(:,:) = vtau(:,:)
             qns_b (:,:) = qns (:,:)
-            ! qsr_b (:,:) = qsr (:,:)
-            emp_b (:,:) = emp (:,:)
-            emps_b(:,:) = emps(:,:)
+            emp_b (:,:) = emp(:,:)
+            sfx_b (:,:) = sfx(:,:)
          ENDIF
       ENDIF
@@ -340,5 +352,5 @@
          ! CALL iom_rstput( kt, nitrst, numrow, 'qsr_b'  , qsr  )
          CALL iom_rstput( kt, nitrst, numrow, 'emp_b'  , emp  )
-         CALL iom_rstput( kt, nitrst, numrow, 'emps_b' , emps )
+         CALL iom_rstput( kt, nitrst, numrow, 'sfx_b' , sfx )
       ENDIF
 
@@ -348,5 +360,7 @@
       IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
          CALL iom_put( "empmr" , emp  - rnf )                   ! upward water flux
-         CALL iom_put( "empsmr", emps - rnf )                   ! c/d water flux
+         CALL iom_put( "saltflx", sfx  )                        ! downward salt flux  
+                                                                ! (includes virtual salt flux beneath ice 
+                                                                ! in linear free surface case)
          CALL iom_put( "qt"    , qns  + qsr )                   ! total heat flux 
          CALL iom_put( "qns"   , qns        )                   ! solar heat flux
@@ -365,5 +379,5 @@
          CALL prt_ctl(tab2d_1=fr_i             , clinfo1=' fr_i     - : ', mask1=tmask, ovlap=1 )
          CALL prt_ctl(tab2d_1=(emp-rnf)        , clinfo1=' emp-rnf  - : ', mask1=tmask, ovlap=1 )
-         CALL prt_ctl(tab2d_1=(emps-rnf)       , clinfo1=' emps-rnf - : ', mask1=tmask, ovlap=1 )
+         CALL prt_ctl(tab2d_1=(sfx-rnf)        , clinfo1=' sfx-rnf  - : ', mask1=tmask, ovlap=1 )
          CALL prt_ctl(tab2d_1=qns              , clinfo1=' qns      - : ', mask1=tmask, ovlap=1 )
          CALL prt_ctl(tab2d_1=qsr              , clinfo1=' qsr      - : ', mask1=tmask, ovlap=1 )
Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 3625)
@@ -56,5 +56,4 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   rnf_tsc_b, rnf_tsc  !: before and now T & S runoff contents   [K.m/s & PSU.m/s]
    
-   REAL(wp) ::   r1_rau0   ! = 1 / rau0 
 
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_rnf       ! structure: river runoff (file information, fields read)
@@ -83,4 +82,5 @@
    END FUNCTION sbc_rnf_alloc
 
+
    SUBROUTINE sbc_rnf( kt )
       !!----------------------------------------------------------------------
@@ -96,5 +96,5 @@
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt          ! ocean time step
-      !!
+      !
       INTEGER  ::   ji, jj   ! dummy loop indices
       !!----------------------------------------------------------------------
@@ -127,7 +127,7 @@
          !
          IF( MOD( kt - 1, nn_fsbc ) == 0 ) THEN
-            rnf(:,:) = rn_rfact * ( sf_rnf(1)%fnow(:,:,1) )  
             !
-            r1_rau0 = 1._wp / rau0
+            rnf(:,:) = rn_rfact * ( sf_rnf(1)%fnow(:,:,1) )       ! updated runoff value at time step kt
+            !
             !                                                     ! set temperature & salinity content of runoffs
             IF( ln_rnf_tem ) THEN                                       ! use runoffs temperature data
@@ -199,5 +199,4 @@
       !!
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp) ::   r1_rau0   ! local scalar
       REAL(wp) ::   zfact     ! local scalar
       !!----------------------------------------------------------------------
@@ -205,5 +204,4 @@
       zfact = 0.5_wp
       !
-      r1_rau0 = 1._wp / rau0
       IF( ln_rnf_depth ) THEN      !==   runoff distributed over several levels   ==!
          IF( lk_vvl ) THEN             ! variable volume case 
@@ -252,10 +250,10 @@
       INTEGER           ::   ji, jj, jk    ! dummy loop indices
       INTEGER           ::   ierror, inum  ! temporary integer
-      !! 
+      !
       NAMELIST/namsbc_rnf/ cn_dir, ln_rnf_emp, ln_rnf_depth, ln_rnf_tem, ln_rnf_sal,   &
          &                 sn_rnf, sn_cnf    , sn_s_rnf    , sn_t_rnf  , sn_dep_rnf,   &  
          &                 ln_rnf_mouth      , rn_hrnf     , rn_avt_rnf, rn_rfact  
       !!----------------------------------------------------------------------
-
+      !
       !                                   ! ============
       !                                   !   Namelist
@@ -273,5 +271,5 @@
       REWIND ( numnam )                         ! Read Namelist namsbc_rnf
       READ   ( numnam, namsbc_rnf )
-
+      !
       !                                         ! Control print
       IF(lwp) THEN
@@ -286,5 +284,5 @@
          WRITE(numout,*) '      multiplicative factor for runoff           rn_rfact     = ', rn_rfact    
       ENDIF
-
+      !
       !                                   ! ==================
       !                                   !   Type of runoff
@@ -395,6 +393,5 @@
             nkrnf = 2
             DO WHILE( nkrnf /= jpkm1 .AND. gdepw_0(nkrnf+1) < rn_hrnf )   ;   nkrnf = nkrnf + 1   ;   END DO
-            IF( ln_sco )   &
-               CALL ctl_warn( 'sbc_rnf: number of levels over which Kz is increased is computed for zco...' )
+            IF( ln_sco )   CALL ctl_warn( 'sbc_rnf: number of levels over which Kz is increased is computed for zco...' )
          ENDIF
          IF(lwp) WRITE(numout,*)
@@ -414,5 +411,5 @@
          nkrnf = 0
       ENDIF
-
+      !
    END SUBROUTINE sbc_rnf_init
 
@@ -438,5 +435,4 @@
       !!                rnfmsk_z vertical structure
       !!----------------------------------------------------------------------
-      !
       INTEGER            ::   inum        ! temporary integers
       CHARACTER(len=140) ::   cl_rnfile   ! runoff file name
@@ -446,17 +442,17 @@
       IF(lwp) WRITE(numout,*) 'rnf_mouth : river mouth mask'
       IF(lwp) WRITE(numout,*) '~~~~~~~~~ '
-
+      !
       cl_rnfile = TRIM( cn_dir )//TRIM( sn_cnf%clname )
       IF( .NOT. sn_cnf%ln_clim ) THEN   ;   WRITE(cl_rnfile, '(a,"_y",i4)' ) TRIM( cl_rnfile ), nyear    ! add year
          IF( sn_cnf%cltype == 'monthly' )   WRITE(cl_rnfile, '(a,"m",i2)'  ) TRIM( cl_rnfile ), nmonth   ! add month
       ENDIF
-  
+      !
       ! horizontal mask (read in NetCDF file)
       CALL iom_open ( cl_rnfile, inum )                           ! open file
       CALL iom_get  ( inum, jpdom_data, sn_cnf%clvar, rnfmsk )    ! read the river mouth array
       CALL iom_close( inum )                                      ! close file
-      
+      !
       IF( nclosea == 1 )    CALL clo_rnf( rnfmsk )                ! closed sea inflow set as ruver mouth
-
+      !
       rnfmsk_z(:)   = 0._wp                                        ! vertical structure 
       rnfmsk_z(1)   = 1.0
Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 3625)
@@ -9,17 +9,18 @@
 
    !!----------------------------------------------------------------------
-   !!   sbc_ssr        : add to sbc a restoring term toward SST/SSS climatology
-   !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
-   USE dom_oce         ! ocean space and time domain
-   USE sbc_oce         ! surface boundary condition
-   USE phycst          ! physical constants
-   USE sbcrnf          ! surface boundary condition : runoffs
-   USE fldread         ! read input fields
-   USE iom             ! I/O manager
-   USE in_out_manager  ! I/O manager
-   USE lib_mpp         ! distribued memory computing library
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE timing          ! Timing
+   !!   sbc_ssr       : add to sbc a restoring term toward SST/SSS climatology
+   !!----------------------------------------------------------------------
+   USE oce            ! ocean dynamics and tracers
+   USE dom_oce        ! ocean space and time domain
+   USE sbc_oce        ! surface boundary condition
+   USE phycst         ! physical constants
+   USE sbcrnf         ! surface boundary condition : runoffs
+   USE fldread        ! read input fields
+   USE iom            ! I/O manager
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! distribued memory computing library
+   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
+   USE timing         ! Timing
+   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
    IMPLICIT NONE
@@ -63,6 +64,6 @@
       !!              - at each nscb time step
       !!                   add a retroaction term on qns    (nn_sstr = 1)
-      !!                   add a damping term on emps       (nn_sssr = 1)
-      !!                   add a damping term on emp & emps (nn_sssr = 2)
+      !!                   add a damping term on sfx        (nn_sssr = 1)
+      !!                   add a damping term on emp        (nn_sssr = 2)
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in   ) ::   kt   ! ocean time step
@@ -156,5 +157,5 @@
             !                                      ! ========================= !
             !
-            IF( nn_sstr == 1 ) THEN                   !* Temperature restoring term
+            IF( nn_sstr == 1 ) THEN                                   !* Temperature restoring term
 !CDIR COLLAPSE
                DO jj = 1, jpj
@@ -168,5 +169,5 @@
             ENDIF
             !
-            IF( nn_sssr == 1 ) THEN                   !* Salinity damping term (salt flux, emps only)
+            IF( nn_sssr == 1 ) THEN                                   !* Salinity damping term (salt flux only (sfx))
                zsrp = rn_deds / rday                                  ! from [mm/day] to [kg/m2/s]
 !CDIR COLLAPSE
@@ -174,13 +175,12 @@
                   DO ji = 1, jpi
                      zerp = zsrp * ( 1. - 2.*rnfmsk(ji,jj) )   &      ! No damping in vicinity of river mouths
-                        &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj,1) )   &
-                        &        / ( sss_m(ji,jj) + 1.e-20   )
-                     emps(ji,jj) = emps(ji,jj) + zerp
-                     erp( ji,jj) = zerp
+                        &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj,1) ) 
+                     sfx(ji,jj) = sfx(ji,jj) + zerp                 ! salt flux
+                     erp(ji,jj) = zerp / MAX( sss_m(ji,jj), 1.e-20 ) ! converted into an equivalent volume flux (diagnostic only)
                   END DO
                END DO
                CALL iom_put( "erp", erp )                             ! freshwater flux damping
                !
-            ELSEIF( nn_sssr == 2 ) THEN               !* Salinity damping term (volume flux, emp and emps)
+            ELSEIF( nn_sssr == 2 ) THEN                               !* Salinity damping term (volume flux (emp) and associated heat flux (qns)
                zsrp = rn_deds / rday                                  ! from [mm/day] to [kg/m2/s]
                zerp_bnd = rn_sssr_bnd / rday                          !       -              -    
@@ -190,9 +190,9 @@
                      zerp = zsrp * ( 1. - 2.*rnfmsk(ji,jj) )   &      ! No damping in vicinity of river mouths
                         &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj,1) )   &
-                        &        / ( sss_m(ji,jj) + 1.e-20   )
+                        &        / MAX(  sss_m(ji,jj), 1.e-20   )
                      IF( ln_sssr_bnd )   zerp = SIGN( 1., zerp ) * MIN( zerp_bnd, ABS(zerp) )
-                     emp (ji,jj) = emp (ji,jj) + zerp
-                     emps(ji,jj) = emps(ji,jj) + zerp
-                     erp (ji,jj) = zerp
+                     emp(ji,jj) = emp (ji,jj) + zerp
+                     qns(ji,jj) = qns(ji,jj) - zerp * rcp * sst_m(ji,jj)
+                     erp(ji,jj) = zerp
                   END DO
                END DO
